//application.h
//ver 0.79
#ifndef _APPLICATION_H
#define _APPLICATION_H

#include <windows.h>
#include <string>

#ifndef WM_MOUSEWHEEL
#define WM_MOUSEWHEEL (WM_MOUSELAST+1)  
#endif
#define GET_WHEEL_DELTA_WPARAM(wParam)  ((short)HIWORD(wParam))

class CApplication
{
public:
	struct WinMainParameter
	{
		HINSTANCE	hInstance;
		LPSTR		lpCmdLine;
		int			nCmdShow;
	};

	struct WindowReference
	{
		std::string strAppName;
		HWND		hWnd;
		int			iWidth;
		int			iHeight;
		bool		bIsFullScreen;
	};

	struct CameraReference
	{
		bool		bRotateCamera;
		float		wheel;
		float		fRotateX;
		float		fRotateY;
	};

public:
	CApplication();
	virtual ~CApplication();

	void    Register(CApplication * pApp, const std::string &strName, int iWidth = 800, int iHeight = 600, bool bFullScreen = false);
	bool	Run();
	bool	CreateMainWindow();
	bool	CreateGraphics();
	static  CApplication *	GetInstance();
	static	void	Release();

	// WinMain Լ CApplication ޽忡  ϵ Ѵ.
	friend int APIENTRY WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow);

	//  ޼ 
	static  LRESULT WINAPI CApplication::WindowProc(HWND hWnd, unsigned int msg, WPARAM wParam, LPARAM lParam);
	virtual void MessageLoop();
	virtual LRESULT WINAPI ProcessMessage(HWND hWnd, unsigned int msg, WPARAM wParam, LPARAM lParam);

protected:
	// ֿ ۾  Update(), Render() ޽忡 Ѵ.
	virtual void Update();
	virtual void Render();
	virtual bool ProcessKey(HWND hWnd, WPARAM wKey);

	virtual HRESULT RenderFrame();
	virtual void Cleanup();

	// CreateMainWindow() 
	virtual bool PrepareWindow();
	virtual bool InitWindow();
	virtual bool PostWindow();

	// CreateGraphics() 
	virtual bool PrepareGraphics();
	virtual bool InitGraphics();
	virtual bool PostGraphics();

	void	MoveMouse(int x, int y);

protected:
	WinMainParameter	m_mainParam;
	WindowReference		m_windowRef;
	CameraReference		m_cameraRef;
	bool				m_bActive;

	POINT		m_lastMousePos;

	class CGraphics * m_pGraphics;
	static CApplication * m_hApplication;
};


#endif