//MyMaterial.cpp
#include <d3d9.h>
#include <d3dx9.h>

#include "MyMaterial.h"


MyMaterial::MyMaterial() : m_pMaterial(NULL)
{
	InitMaterial();
}
//------------------------------------------------------------------------------------------
MyMaterial::~MyMaterial()
{

}
//------------------------------------------------------------------------------------------
void MyMaterial::InitMaterial()
{
	m_pMaterial = new D3DMATERIAL9;
	m_pMaterial->Ambient = D3DXCOLOR(0.7f, 0.7f, 0.7f, 1.0f);
	m_pMaterial->Diffuse = D3DXCOLOR(0.7f, 0.7f, 0.7f, 1.0f);
	m_pMaterial->Specular = D3DXCOLOR(0.7f, 0.7f, 0.7f, 1.0f);
	m_pMaterial->Emissive = D3DXCOLOR(0.0f, 0.0f, 0.0f, 1.0f);
	m_pMaterial->Power = 0.5f;
}
//------------------------------------------------------------------------------------------
void MyMaterial::Release()
{
	if(m_pMaterial)
		delete m_pMaterial;

	m_pMaterial = 0L;
}
//------------------------------------------------------------------------------------------
void MyMaterial::SetMaterial(IDirect3DDevice9* pDevice)
{
	pDevice->SetMaterial(m_pMaterial);
}
//------------------------------------------------------------------------------------------
D3DCOLORVALUE& MyMaterial::GetAmbient()
{
	return m_pMaterial->Ambient;
}
//------------------------------------------------------------------------------------------
void MyMaterial::SetAmbient(float r, float g, float b)
{
	m_pMaterial->Ambient = D3DXCOLOR(r, g, b, 1.0f);
}
//------------------------------------------------------------------------------------------
D3DCOLORVALUE& MyMaterial::GetDiffuse()
{
	return m_pMaterial->Diffuse; 	
}
//------------------------------------------------------------------------------------------
void MyMaterial::SetDiffuse(float r, float g, float b)
{
	m_pMaterial->Diffuse = D3DXCOLOR(r, g, b, 1.0f);
}
//------------------------------------------------------------------------------------------
D3DCOLORVALUE& MyMaterial::GetSpecular()
{
	return m_pMaterial->Specular;
}
//------------------------------------------------------------------------------------------
void MyMaterial::SetSpecular(float r, float g, float b)
{
	m_pMaterial->Specular = D3DXCOLOR(r, g, b, 1.0f);
}
//------------------------------------------------------------------------------------------
D3DCOLORVALUE& MyMaterial::GetEmissive()
{
	return m_pMaterial->Emissive;
}
//------------------------------------------------------------------------------------------
void MyMaterial::SetEmissive(float r, float g, float b)
{
	m_pMaterial->Emissive = D3DXCOLOR(r, g, b, 1.0f);
}
//------------------------------------------------------------------------------------------
float MyMaterial::GetPower()
{
	return m_pMaterial->Power;
}
//------------------------------------------------------------------------------------------
void MyMaterial::SetPower(float fPower)
{
	m_pMaterial->Power = fPower;
}