//MyMesh.cpp
#include <windows.h>
#include "MyVertex.h"
#include "MyMesh.h"


MyMesh::MyMesh() : 
m_iVertexCount(0), m_pDeviceVertex(0), m_pVertexData(0), m_pVertexColor(0),
m_pNormal(0), m_pBaseUV(0)
{
	
}
//---------------------------------------------------------------------------------------
MyMesh::~MyMesh()
{
	Release();
}
//---------------------------------------------------------------------------------------
void MyMesh::Release()
{
	if(m_pVertexData)
		delete [] m_pVertexData;
	if(m_pVertexColor)
		delete [] m_pVertexColor;
	if(m_pNormal)
		delete [] m_pNormal;
	if(m_pBaseUV)
		delete [] m_pBaseUV;
	if(m_pDeviceVertex)
		delete m_pDeviceVertex;

	m_pVertexData = 0;
	m_pVertexColor = 0;
	m_pNormal = 0;
	m_pBaseUV = 0;
	m_pDeviceVertex = 0;
}
//---------------------------------------------------------------------------------------
void MyMesh::SetNumber(int iVertexCount, int iPrimitiveCount)
{
	m_iVertexCount = iVertexCount;
	m_iPrimitiveCount = iPrimitiveCount;
}
//---------------------------------------------------------------------------------------
int MyMesh::GetVertexNumber()
{
	return m_iVertexCount;
}
//---------------------------------------------------------------------------------------
int MyMesh::GetPrimitiveNumber()
{
	return m_iPrimitiveCount;
}
//---------------------------------------------------------------------------------------
MyVector3* MyMesh::GetVertexData()
{
	return m_pVertexData;
}
//---------------------------------------------------------------------------------------
void MyMesh::SetVertexData(MyVector3* pVertex)
{
	m_pVertexData = pVertex;
}
//---------------------------------------------------------------------------------------
MyVector2* MyMesh::GetTextureUV()
{
	return m_pBaseUV;
}
//---------------------------------------------------------------------------------------
void MyMesh::SetTextureUV(MyVector2* pUV)
{
	m_pBaseUV = pUV;
}
//---------------------------------------------------------------------------------------
DWORD* MyMesh::GetVertexColor()
{
	return m_pVertexColor;
}
//---------------------------------------------------------------------------------------
void MyMesh::SetVertexColor(DWORD* pColor)
{
	m_pVertexColor = pColor;
}
//---------------------------------------------------------------------------------------
MyVertex* MyMesh::GetDeviceVertex()
{
	return m_pDeviceVertex;
}
//---------------------------------------------------------------------------------------
void MyMesh::SetDeviceVertex(MyVertex* pMyVertex)
{
	m_pDeviceVertex = pMyVertex;
}
//---------------------------------------------------------------------------------------
