float4x4 g_matWorldViewProj;
float4x4 g_matWorldView;

//material
float4 k_d;
float4 k_a;
	
float4 i_d = { 0.7f, 0.7f, 0.7f, 1.0f};
float4 i_a = { 0.3f, 0.3f, 0.3f, 1.0f};
float3 dir = { 0.6f, -0.6f,0.6f};	
	
texture  baseMap;

sampler baseMap_Sampler = sampler_state
{
	Texture = <baseMap>;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = NONE;
};


struct VS_OUTPUT
{
    float4 Pos  : POSITION;
    float4 Col  : COLOR0;
    float2 texCoord : TEXCOORD0;
};


VS_OUTPUT VS(float4 Pos : POSITION, float3 inNorm : NORMAL, float2 texCoord : TEXCOORD0)     
{
    VS_OUTPUT Out = (VS_OUTPUT)0;
    Out.Pos = mul(Pos, g_matWorldViewProj);
    
    //Calculate Light           
    float3 L = -dir;
    float3 N = normalize( mul(inNorm, g_matWorldView));

    Out.Col = i_a * k_a + i_d * k_d * max( dot(N, L), 0);                   
	Out.texCoord = texCoord;
    return Out;
}

float4 PS(float4 Col :COLOR0, float2 texCoord : TEXCOORD0) : COLOR
{
    float4 color = tex2D( baseMap_Sampler, texCoord);
    return  color * Col;
}

float4 PS_NoTexture(float4 Col :COLOR0, float2 texCoord : TEXCOORD0) : COLOR
{
    return  Col;
}

technique BasicTest
{
    pass P0
    {
        VertexShader = compile vs_2_0 VS();
        PixelShader  = compile ps_2_0 PS();
    }
}

technique NoTextureTest
{
    pass P0
    {
        VertexShader = compile vs_2_0 VS();
        PixelShader  = compile ps_2_0 PS_NoTexture();
    }
}
